/* Sample Solution:     Using Packages */
CREATE OR REPLACE PACKAGE big_bucks AS
  PROCEDURE tot_pay  (salary      IN NUMBER, 
                      commission  IN NUMBER,
                      total_pay   IN OUT NUMBER);
  FUNCTION avg_pay  (salary_in IN number)
          RETURN char;
END;
/
/* Sample Solution:	Using Packages (continued) */
CREATE OR REPLACE PACKAGE BODY big_bucks AS
  PROCEDURE tot_pay  (salary      IN NUMBER, 
                      commission  IN NUMBER,
                      total_pay   IN OUT NUMBER)
      IS
      BEGIN
          total_pay := salary + commission;
      END;
  FUNCTION avg_pay  (salary_in IN number)
          RETURN char
      IS
         response   char(2);
         avg_pay    number(7,2);
      BEGIN
        select avg(sal) into avg_pay from emp;
        if salary_in < avg_pay
        then
           response := 'OK';
        else
           response := 'NO';
        end if;
        RETURN(response);
      END;
  FUNCTION exempt(in_empno IN NUMBER)
          RETURN char 
      IS
         result      char(3);
         person_job  char(15);
      BEGIN
        SELECT job INTO person_job
           from emp 
           where empno = in_empno;
        IF person_job = 'PRESIDENT'
        THEN
          result := 'YES';
        ELSE
          result := 'NO ';
        END IF;
        RETURN(result);
      END;
END big_bucks;
/

/* Sample Solution:	Using Packages (continued) */
DECLARE
   emp_rec emp%ROWTYPE;
   pay_total number(9,2);
   cursor emprows is 
      select * from emp;
          
BEGIN
   open emprows;
   loop
       fetch emprows into emp_rec;
       exit when emprows%notfound;
       big_bucks.tot_pay(emp_rec.sal,
                         emp_rec.comm,
                         pay_total);
       if big_bucks.avg_pay(pay_total) = 'NO'
       then
           insert into bonus
                values (emp_rec.ename,
                        emp_rec.job,
                        emp_rec.sal,
                        emp_rec.comm);
       end if;
   end loop;
   close emprows;
END;
/
