drop materialized view sales_mview;
CREATE materialized VIEW sales_mview AS
	SELECT   substr(country_name,1,20) country
		,substr(prod_name,1,15)    product
                ,prod_id                   prodid
		,calendar_year             year
		,SUM(amount_sold)          tot_amt
                ,SUM(quantity_sold)        tot_qty
		,COUNT(amount_sold)        tot_sales
		FROM sh.sales join sh.times
                         on sales.time_id = times.time_id
                              join sh.products
                         on sales.prod_id = products.prod_id
                              join sh.customers
                         on sales.cust_id = customers.cust_id
                              join sh.countries
                         on customers.country_id = countries.country_id
 	GROUP BY country_name
                ,prod_name
                ,prod_id
                ,calendar_year
        ORDER BY country
                ,product
                ,year
/
