/* Sample Solution:	PL/SQL Looping and Arithmetic */

declare
  indate emp.hiredate%type;
  insal  emp.sal%type;
  inempno emp.empno%type;
  nextdate date;
  checkamt number(7,2);     -- specifying size shows rounding error
  --checkamt number;       -- no precision masks rounding error
  totval number := 0;
begin
    begin
      select empno,hiredate,sal
        into inempno,indate,insal
        from emp
        where empno = 7788;
      checkamt := insal / 52;
      nextdate := next_day(indate,'FRIDAY');
    exception
      when no_data_found
	then dbms_output.put_line('No record found');
	     return;
    end;
  dbms_output.put_line('Employee HIREDATE is ' || to_char(indate,'mm/dd/yyyy'));
  
  -- print first 52 weekly pay amounts
  for loopct in 1 .. 52 loop
    totval := totval + checkamt;
    dbms_output.put_line('Check for: ' || to_char(nextdate,'mm/dd/yyyy') 
			 || ' is for ' || to_char(checkamt,'fm99,999.99'));
    nextdate := nextdate + 7;
  end loop;

  -- print total amount of first 52 weeks
    dbms_output.put_line('Total for 52 weeks is  ' || to_char(totval,'999,999.99'));
    dbms_output.put_line('Original SAL is        ' || to_char(insal,'999,999.99'));
end;
/
